/* mnr6d.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    doublereal zf;
    integer kr;
    doublereal akr, df[15];
} mmkrd_;

#define mmkrd_1 mmkrd_

/* Subroutine */ int mnr6d_c(doublereal *x, doublereal *xe, integer *i0,
        doublereal *a, doublereal *b, integer *n, S_fp func, doublereal *f, 
        doublereal *fe, S_fp grad, doublereal *g, doublereal *ge,
        doublereal *up, doublereal *rm, integer *irm, real *tmax,
        integer *ierr)
{
    /* System generated locals */
    integer i__1, i__2;
    doublereal d__1;

    /* Local variables */
    static integer kmax, i__, j, k;
    extern /* Subroutine */ int mlu01d_c(doublereal *, integer *),
            mnr11d_c(doublereal *, doublereal *, doublereal *, integer *),
            mnr64d_c(doublereal *, doublereal *, doublereal *, doublereal *,
            S_fp, doublereal *, integer *, doublereal *, doublereal *,
            doublereal *, doublereal *, integer *),
            utmn05_c(real *);
    static integer i1, i4, i5, n1;
    static real t0, t1;
    extern /* Subroutine */ int mnr2hd_c(doublereal *, integer *, doublereal *,
             doublereal *, doublereal *, integer *, integer *, integer *), 
            mnr6fd_c(doublereal *, doublereal *, integer *, doublereal *,
            doublereal *, doublereal *, integer *, doublereal *, integer *), 
            mnru3d_c(integer *, doublereal *, doublereal *, doublereal *,
            doublereal *, doublereal *, doublereal *, integer *);
    static integer ki;
    static real dt;
    static integer ip, kn;
    static doublereal fs[4], ft;
    static integer pr;
    extern /* Subroutine */ int mmkrid_c(integer *, doublereal *, integer *),
            mnrugd_c(doublereal *, doublereal *, integer *, doublereal *,
            doublereal *, doublereal *, integer *);
    static integer ig1, pr1, idk;
    static doublereal cdx;
    static integer idx, iqk, kit;
    static doublereal eps;
    static integer kpr1;

/*  METO BOHA-ETEPA-AYA                  */
/*  MHMA HA APAEEEE                   */
    /* Parameter adjustments */
    --irm;
    --ge;
    --g;
    --b;
    --a;
    --i0;
    --up;
    --rm;

    /* Function Body */
    kpr1 = 0;
    pr1 = 0;
    utmn05_c(&t0);
    eps = up[1];
    mmkrd_1.kr = (integer) (up[2] + .5);
    mmkrd_1.akr = up[3];
    cdx = up[4];
    kmax = (integer) rm[1];
    fs[0] = 100.;
    for (i__ = 2; i__ <= 4; ++i__) {
        fs[i__ - 1] = fs[i__ - 2] + 100.;
/* L10: */
    }
    ig1 = 4;
    idk = ig1 + *n;
/* Computing 2nd power */
    i__1 = *n;
    iqk = idk + i__1 * i__1;
    idx = iqk + *n;
    (*func)(x, f, fe);
    rm[2] = 1.;
    (*grad)(x, &rm[ig1], &ge[1], &i0[1]);
    rm[3] = 1.;
    kn = 0;
    rm[1] = 0.;
    k = ig1 - 1;
/*  OPMPOBAHE BEKTOPA I01                         */
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
        irm[i__] = i0[i__];
/* L20: */
    }
    mnr6fd_c(x, xe, n, &a[1], &b[1], &rm[ig1], &irm[1], &eps, &pr);
/*  HAAHOE OPMPOBAHE MATP DK                */
L30:
    mlu01d_c(&rm[idk], n);
    n1 = 1;
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
        if (irm[i__] == 0) {
            goto L40;
        }
        ++n1;
L40:
        ;
    }
    i__1 = n1;
    for (j = 1; j <= i__1; ++j) {
/*  BCEHE BEKTOPA DX                            */
        *ierr = 0;
        mnr11d_c(&rm[idx], &rm[ig1], &rm[idk], n);
/*   KOPPEKTPOBKA DX C YETOM PAH                */
/* L50: */
        mnrugd_c(x, xe, n, &a[1], &b[1], &rm[idx], &irm[1]);
/*  OCK YE TOK HA HAPABEH DX             */
        mnr64d_c(x, xe, f, &rm[idx], (S_fp)func, fe, n, &cdx, &rm[2], &rm[iqk],
                 &ft, &pr);
        ++rm[1];
        i__2 = *n;
        for (i__ = 1; i__ <= i__2; ++i__) {
            ki = k + i__;
            g[i__] = rm[ki];
/* L60: */
        }
        if (pr == 0) {
            goto L70;
        }
        *ierr = *ierr * 10 + 1;
        ++kn;
        if (kn - 2 >= 0) {
            goto L180;
        } else {
            goto L30;
        }
L70:
        mnr6fd_c(x, xe, n, &a[1], &b[1], &rm[4], &irm[1], &eps, &pr);
        for (i__ = 1; i__ <= 3; ++i__) {
            i5 = 5 - i__;
            i4 = 4 - i__;
            fs[i5 - 1] = fs[i4 - 1];
/* L80: */
        }
        fs[0] = *f - ft;
        *f = ft;
        for (i__ = 1; i__ <= 4; ++i__) {
            if (fs[i__ - 1] > *fe) {
                goto L100;
            }
/* L90: */
        }
        *ierr = *ierr * 10 + 2;
        goto L180;
L100:
        kn = 0;
        (*grad)(x, &rm[ig1], &ge[1], &irm[1]);
        i__2 = *n;
        for (i__ = 1; i__ <= i__2; ++i__) {
            ki = k + i__;
            rm[ki] = irm[i__] * rm[ki];
/* L110: */
        }
        ++rm[3];
        if (pr == 1) {
            goto L30;
        }
/*    POBEPKA KPTEPEB OCTAHOBA                    */
        i__2 = *n;
        for (i__ = 1; i__ <= i__2; ++i__) {
            i1 = ig1 - 1 + i__;
            if ((d__1 = rm[i1], abs(d__1)) > ge[i__]) {
                goto L130;
            }
/* L120: */
        }
        *ierr = *ierr * 10 + 3;
        goto L180;
L130:
        if (rm[1] - kmax >= 0.) {
            *ierr = *ierr * 10 + 4;
        }
        utmn05_c(&t1);
        dt = t1 - t0;
        if (dt > *tmax) {
            *ierr = *ierr * 10 + 5;
        }
        kit = (integer) (rm[1] + .5);
        mmkrid_c(&kit, f, &pr1);
        if (pr1 == 1) {
            goto L140;
        }
        kpr1 = 0;
        goto L150;
L140:
        ++kpr1;
        if (kpr1 > 3) {
            *ierr = *ierr * 10 + 6;
        }
L150:
        if (*ierr != 0) {
            goto L200;
        }
/* L160: */
/*  EPECET MATP DK                              */
        mnru3d_c(n, &rm[idk], &rm[idx], &rm[iqk], &g[1], &rm[ig1], &eps, &ip);
        if (ip == 1) {
            goto L30;
        }
/* L170: */
    }
    goto L30;
L180:
    (*grad)(x, &rm[ig1], &ge[1], &i0[1]);
/*    OTKA PACPEH POCTPAHCTBA                */
/* L190: */
    mnr2hd_c(x, n, &rm[ig1], &a[1], &b[1], &i0[1], &irm[1], &pr);
    if (pr == 1) {
        goto L30;
    }
L200:
    return 0;
} /* mnr6d_c */
